#
# spec file for package otrs (Version 1.3.3)
#
# Copyright (c) 2005 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org
#

# neededforbuild  
# usedforbuild    aaa_base acl attr bash bind-utils bison bzip2 coreutils cpio cpp cvs cyrus-sasl db devs diffutils e2fsprogs file filesystem fillup findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv kbd less libacl libattr libgcc libstdc++ libxcrypt m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-devel pam-modules patch permissions popt ps rcs readline sed sendmail shadow strace syslogd sysvinit tar texinfo timezone unzip util-linux vim zlib zlib-devel autoconf automake binutils cracklib gcc gdbm gettext libtool perl rpm

Name:         otrs
Version:      1.3.3
Release:      2
%define otrs_sub_release 01
License:      GPL
Group:        Productivity/Networking/Email/Utilities
URL:          http://otrs.org/
Autoreqprov:  on
Requires:     http_daemon perl perl-DBI perl-GD perl-Net-DNS perl-Digest-MD5 apache2-mod_perl mysql mysql-client perl-Msql-Mysql-modules mysql-shared fetchmail procmail
PreReq:       %insserv_prereq %fillup_prereq /usr/sbin/useradd /usr/sbin/usermod /bin/sed /bin/grep /bin/mv /bin/mkdir /bin/cat /bin/hostname /bin/mktemp /usr/bin/getent /usr/bin/basename
Source:       ftp://ftp.otrs.org/pub/otrs/%{name}-%{version}-%{otrs_sub_release}.tar.bz2
Source1:      sysconfig.otrs
Source2:      otrs.README
Patch:        otrs-init.diff
Patch1:       otrs-apache2.conf.diff
Summary:      Open Ticket Request System
BuildRoot:    %{_tmppath}/%{name}-%{version}-build
%define otrsdoc_dir_files CHANGES COPYING CREDITS INSTALL README* TODO UPGRADING doc
%if %ul_version >= 1
	%define	VENDOR UnitedLinux
%else
%if "%_vendor" == "suse"
	%define	VENDOR SUSE
%else
	%define	VENDOR %_vendor
%endif
%endif

%description
OTRS is an Open source Ticket Request System with many features to
manage customer telephone calls and e-mails. It is distributed under
the GNU General Public License (GPL) and tested on Linux, Solaris, AIX,
FreeBSD, and Mac OS 10.x. Do you receive many e-mails and want to
answer them with a team of agents? You are going to love the OTRS!

Feature list:

Web-Interface: - Agent web-interface for viewing and working on all
   customer requests

- Admin web-interface for changing system settings

- Customer web-interface for viewing and sending information to the
   agents

- Web-interface with themes support

- Multi-language support (Bulgarian, Dutch, English, Finnish,
   French, German, and Spanish)

- Customize the output template's (dtl) release independently

- Web-interface with attachment support

- Easy and logical to use

E-mail-Interface: - MIME support (attachments)

- dispatch incoming e-mail via e-mail address or x-header

- autoresponders for customers by incoming e-mail (per queue)

- e-mail notification to the agent by new tickets, follow-ups, or
   lock timeouts

Ticket: - custom queue view and queue view of all requests

- Ticket locking

- Ticket replies (standard responses)

- Ticket autoresponders per queue

- Ticket history, evolution of ticket status, and actions taken on
   ticket

- ability to add notes (with different note types) to a ticket

- Ticket zoom feature

- Tickets can be bounced or forwarded to other e-mail addresses

- Ticket can be moved to a different queue (this is helpful if
   e-mails are for a specific subject)

- Ticket priority

- Ticket time accounting

- content full text search

System: - creation and configuration of user accounts and groups

- creation of standard responses

- signature configuration per queue

- salutation configuration per queue

- e-mail notification of administrators

- e-mail notification sent to problem reporter (by create, locked,
   deleted, moved, and closed)

- submitting update-info (via e-mail or web interface)

- deadlines for trouble tickets

- ASP (active service providing) support

- TicketHook free setable like 'Call#', 'MyTicket#', 'Request#' or
   'Ticket#'

- Ticket number format free setable

- different levels of permissions and access rights

- central database, support for different SQL databases (MySQL and
   PostgreSQL for example)

- user authentication against database or ldap directory

- easy to develop your own add-ons (OTRS API)

- easy to write different front-ends (for example: X Window System,
   console)

- a fast and useful application



Authors:
--------
    Antti Kmrinen <antti at seu.net>
    Carsten Gross <carsten at siski.de>
    Franz Breu <breu.franz at bogen.net>
    Fred van Dijk <fvandijk at marklin.nl>
    Nicolas Goralski <ngoralski at oceanet-technology.com>
    Stefan Wintermeyer <stefan at wintermeyer.de>
    Vladimir Gerdjikov <gerdjikov at gerdjikovs.net>
    Martin Edenhofer <martin at otrs.org>

%prep
%setup -n otrs
%patch -p1
%patch1 -p1
find -name ".cvsignore" -type f | xargs rm -fv

%build
/usr/sbin/useradd -r -d /opt/otrs -s /bin/false -c "OTRS System User" -g nogroup otrs 2>/dev/null || :
# copy config file
cp -a Kernel/Config.pm.dist Kernel/Config.pm
cd Kernel/Config/
for file in *.dist
do
	cp -a $file `basename $file .dist`
done
cd ../../
# copy all crontab dist files
for file in var/cron/*.dist
do
mv $file var/cron/`basename $file .dist`
done
rm INSTALL.RedHat
mv INSTALL.SuSE INSTALL

%install
[ "${RPM_BUILD_ROOT}" != "/" -a -d ${RPM_BUILD_ROOT} ] && rm -rf ${RPM_BUILD_ROOT}
export DESTROOT="/opt/otrs/"
mkdir -p \
	${RPM_BUILD_ROOT}/etc/init.d \
	${RPM_BUILD_ROOT}/etc/sysconfig \
	${RPM_BUILD_ROOT}/${DESTROOT}/ \
	${RPM_BUILD_ROOT}/%{_sbindir} \
	${RPM_BUILD_ROOT}/var/adm/fillup-templates
cp -a . ${RPM_BUILD_ROOT}/${DESTROOT}
# install README
cp -p %{S:2} README.%VENDOR
# remove files that are part of the docdir
pushd ${RPM_BUILD_ROOT}/${DESTROOT}
rm -rf %{otrsdoc_dir_files}
popd
# install sysconfig file and init script
install -m 644 ${RPM_SOURCE_DIR}/sysconfig.otrs $RPM_BUILD_ROOT/%{_var}/adm/fillup-templates/
install -m 755 scripts/suse-rcotrs ${RPM_BUILD_ROOT}/etc/init.d/otrs
ln -fs ../../etc/init.d/otrs ${RPM_BUILD_ROOT}/%{_sbindir}/rcotrs
# set permission
${RPM_BUILD_ROOT}/opt/otrs/bin/SetPermissions.sh ${RPM_BUILD_ROOT}/opt/otrs otrs wwwrun nogroup www
chgrp -R root ${RPM_BUILD_ROOT}/opt/otrs
chgrp -R www ${RPM_BUILD_ROOT}/opt/otrs/var/log

%preun
%stop_on_removal otrs
:

%pre
# Are we in update mode?
if [ ${1:-0} -gt 1 ]; then
	# Set new OTRS homedir and initial group for old installations
	getent passwd otrs | grep /opt/OpenTRS >/dev/null && \
		usermod -d /opt/otrs -g nogroup otrs
fi
/usr/sbin/useradd -r -d /opt/otrs -s /bin/false -c "OTRS System User" -g nogroup otrs 2>/dev/null || :

%post
# fill otrs sysconfig file
%{fillup_and_insserv otrs}
function addApacheConf()
{
	OTRSINCLUDE=$1; APACHERC=$2; INCLUDETAG=$3; INCLUDE_FILES=""
	. ${APACHERC}
	for file in ${!INCLUDETAG}; do
		test ${file} = ${OTRSINCLUDE} && return
		INCLUDE_FILES="${INCLUDE_FILES}${file} "
	done
   FILEBASENAME=$( basename ${APACHERC})
	TMPFILE=$( mktemp /var/tmp/${FILEBASENAME}.otrs.sysconfig.XXXXXX)
	if [ $? -ne 0 ]; then
		echo -e "Can't create temp file. Please add ${OTRSINCLUDE}\nmanually to ${INCLUDETAG} in ${APACHERC}."
		return
	fi
	chmod --reference=${APACHERC} ${TMPFILE}
	sed "s+^${INCLUDETAG}.*$+${INCLUDETAG}=\"${INCLUDE_FILES}${OTRSINCLUDE}\"+" ${APACHERC} > ${TMPFILE} && \
		mv ${TMPFILE} ${APACHERC}
}
# add httpd.include.conf to /etc/sysconfig/apache
APACHERC="etc/sysconfig/apache"
if test -e ${APACHERC}; then
	OTRSINCLUDE="/opt/otrs/scripts/apache-httpd.include.conf"
	INCLUDETAG="HTTPD_CONF_INCLUDE_FILES"
	addApacheConf ${OTRSINCLUDE} ${APACHERC} ${INCLUDETAG}
fi
# add suse-httpd.include.conf to /etc/sysconfig/apache2
APACHERC="etc/sysconfig/apache2"
if test -e ${APACHERC}; then
	OTRSINCLUDE="/opt/otrs/scripts/apache2-httpd.include.conf"
	INCLUDETAG="APACHE_CONF_INCLUDE_FILES"
	addApacheConf ${OTRSINCLUDE} ${APACHERC} ${INCLUDETAG}
fi
# if rpm is not in update mode
if ! [ ${FIRST_ARG:-0} -gt 1 ]; then
	if [ -z "${YAST_IS_RUNNING}" ]; then
		echo
		echo About the initial setup of otrs, please read 
		echo /usr/share/doc/packages/otrs/README.%VENDOR\!
		echo
	fi
fi
exit 0

%postun
%restart_on_update otrs
%insserv_cleanup

%clean
[ "${RPM_BUILD_ROOT}" != "/" -a -d ${RPM_BUILD_ROOT} ] && rm -rf ${RPM_BUILD_ROOT}

%files
%config(noreplace) /opt/otrs/Kernel/Config.pm
/opt/otrs/Kernel/Config.pm.dist
%config(noreplace) /opt/otrs/Kernel/Config/GenericAgent.pm
/opt/otrs/Kernel/Config/GenericAgent.pm.*
%config(noreplace) /opt/otrs/Kernel/Config/ModulesCusto*.pm
%config(noreplace) %attr(660,otrs,www) /opt/otrs/var/log/TicketCounter.log
%config(noreplace) /opt/otrs/.procmailrc
%config(noreplace) /opt/otrs/.fetchmailrc
%config(noreplace) /opt/otrs/.mailfilter
%config(noreplace) /opt/otrs/Kernel/Output/HTML/Standard/*.dtl
%config(noreplace) /opt/otrs/Kernel/Output/HTML/Lite/*.dtl
%config(noreplace) /opt/otrs/Kernel/Language/*.pm
%config(noreplace) /opt/otrs/var/cron/*
/etc/init.d/otrs
/usr/sbin/rcotrs
%dir /opt/otrs
%dir /opt/otrs/Kernel
%dir /opt/otrs/Kernel/Config
%dir /opt/otrs/Kernel/Output
%dir /opt/otrs/Kernel/Output/HTML
%dir /opt/otrs/Kernel/Output/HTML/Lite
%dir /opt/otrs/Kernel/Output/HTML/Standard
%dir /opt/otrs/Kernel/Language
%dir /opt/otrs/var
%dir /opt/otrs/var/cron
%dir %attr(770,otrs,www) /opt/otrs/var/log
%dir /opt/otrs/var/pics
/opt/otrs/RELEASE
/opt/otrs/Kernel/Config/Modules.pm
/opt/otrs/Kernel/Config/Defaults.pm
/opt/otrs/Kernel/Language.pm
/opt/otrs/Kernel/Modules/
/opt/otrs/Kernel/Output/HTML/*.pm
/opt/otrs/Kernel/System/
/opt/otrs/bin/
/opt/otrs/scripts/
/opt/otrs/var/article/
/opt/otrs/var/httpd/
/opt/otrs/var/sessions/
/opt/otrs/var/spool/
/opt/otrs/var/tmp/
/opt/otrs/var/pics/stats/
/opt/otrs/Kernel/cpan-lib*
%doc %{otrsdoc_dir_files}
%{_var}/adm/fillup-templates/sysconfig.otrs

%changelog -n otrs
* Thu Dec 01 2005 - lmuelle@suse.de
- Update to 1.3.3; [#135006]; CVE-2005-3893, CVE-2005-3894, CVE-2005-3895.
* Wed Dec 08 2004 - lmuelle@suse.de
- Add information to the README.SUSE to add "perl" to APACHE_MODULES;
  [#48857].
* Mon Dec 06 2004 - lmuelle@suse.de
- Ensure to allow HTTP access to /otrs by default; [#48906].
- Use Apache 2 by default for OTRS_USED_WEBSERVER_RCSCRIPT; [#48904].
- Ensure %%preun returns with 0 even %%stop_on_removal otrs not; [#48858].
* Wed Oct 27 2004 - lmuelle@suse.de
- Update to version 1.3.2.
* Sat Sep 25 2004 - lmuelle@suse.de
- Update to version 1.3.1.
* Fri Jul 23 2004 - ro@suse.de
- do not send a mail on installation
* Wed Jul 14 2004 - lmuelle@suse.de
- Update to version 1.2.4.
- Add try-restart to the init script, stop_on_removal to preun and
  restart_on_udpate to postun.
* Mon Jun 14 2004 - ro@suse.de
- requires: replace mod_perl with apache2-mod_perl
* Fri Apr 02 2004 - lmuelle@suse.de
- update to version 1.2.3
* Tue Mar 16 2004 - lmuelle@suse.de
- fix to paragraph 6 of the README
* Fri Mar 05 2004 - lmuelle@suse.de
- update to version 1.2.2
- remove userdel from PreReq
* Thu Sep 18 2003 - poeml@suse.de
- set permissions of files that need write access by both "otrs"
  user and "apache" user to group "www" [#29824]
- add a README, and send the mail to root only on first
  installation [#27211]
* Mon Sep 01 2003 - mmj@suse.de
- Add sysconfig metadata [#28913]
* Sun Jun 22 2003 - lmuelle@suse.de
- finaly remove userdel in %%postun
- add sanity checks while adding apache include file to the apache sysconfig
  file
- replace requires apache by http_daemon
* Sat Jun 21 2003 - lmuelle@suse.de
- update to version 1.1.1
- add missing directories
- use mktemp im %%post; add /bin/mktemp to PreReq
- use getent passwd otrs in %%post
- temporarily disable userdel in the %%postun
* Tue Mar 18 2003 - lmuelle@suse.de
- change group ownership for most files to root, #25543
- call hostname only if /etc/HOSTNAME exists and is greater than zero, #25495
* Tue Feb 18 2003 - lmuelle@suse.de
- add separate binaries to PreReq
- add missing files and directories to %%files section
- add informational message on stdout if installed without YaST
* Tue Feb 18 2003 - lmuelle@suse.de
- add patch to fix permission settings
- remove defattr from files section
* Mon Feb 17 2003 - lmuelle@suse.de
- check if ${RPM_BUILD_ROOT} is not / in %%clean section
* Tue Feb 11 2003 - lmuelle@suse.de
- update to version 1.0.1
* Tue Sep 17 2002 - ro@suse.de
- removed bogus self-provides
* Tue Aug 20 2002 - mmj@suse.de
- Correct PreReq
* Tue Aug 06 2002 - kukuk@suse.de
- Fix Requires: perl-Syslog -> perl-Unix-Syslog
* Mon Aug 05 2002 - kukuk@suse.de
- Remove perl-Digest-MD5/perl-MIME-Base64 from Requires, they are
  now part of main perl package.
* Fri Jun 14 2002 - ro@suse.de
- always use macros when calling insserv
* Tue Mar 12 2002 - kukuk@suse.de
- Create the new user as system account in the free range 100-499
* Wed Feb 20 2002 - uli@suse.de
- initial package
